diff --git a/src/backend/commands/explain.c b/src/backend/commands/explain.c
index a40d03d35f3..fd7d4887e69 100644
--- a/src/backend/commands/explain.c
+++ b/src/backend/commands/explain.c
@@ -1218,6 +1218,9 @@ ExplainPreScanNode(PlanState *planstate, Bitmapset **rels_used)
 			*rels_used = bms_add_members(*rels_used,
 										 ((CustomScan *) plan)->custom_relids);
 			break;
+		case T_GraphScan:
+			/* GraphScan scans a property graph, no specific relids */
+			break;
 		case T_ModifyTable:
 			*rels_used = bms_add_member(*rels_used,
 										((ModifyTable *) plan)->nominalRelation);
@@ -1525,6 +1528,9 @@ ExplainNode(PlanState *planstate, List *ancestors,
 			else
 				pname = sname;
 			break;
+		case T_GraphScan:
+			pname = sname = "Graph Scan";
+			break;
 		case T_Material:
 			pname = sname = "Materialize";
 			break;
@@ -1682,6 +1688,7 @@ ExplainNode(PlanState *planstate, List *ancestors,
 			break;
 		case T_ForeignScan:
 		case T_CustomScan:
+		case T_GraphScan:
 			if (((Scan *) plan)->scanrelid > 0)
 				ExplainScanTarget((Scan *) plan, es);
 			break;
@@ -2171,6 +2178,14 @@ ExplainNode(PlanState *planstate, List *ancestors,
 					css->methods->ExplainCustomScan(css, ancestors, es);
 			}
 			break;
+		case T_GraphScan:
+			{
+				show_scan_qual(plan->qual, "Filter", planstate, ancestors, es);
+				if (plan->qual)
+					show_instrumentation_count("Rows Removed by Filter", 1,
+											   planstate, es);
+			}
+			break;
 		case T_NestLoop:
 			show_upper_qual(((NestLoop *) plan)->join.joinqual,
 							"Join Filter", planstate, ancestors, es);
@@ -2424,6 +2439,9 @@ ExplainNode(PlanState *planstate, List *ancestors,
 			ExplainCustomChildren((CustomScanState *) planstate,
 								  ancestors, es);
 			break;
+		case T_GraphScan:
+			/* GraphScan has no custom children to display */
+			break;
 		default:
 			break;
 	}
diff --git a/src/backend/executor/Makefile b/src/backend/executor/Makefile
index 11118d0ce02..ee75a819eba 100644
--- a/src/backend/executor/Makefile
+++ b/src/backend/executor/Makefile
@@ -44,6 +44,7 @@ OBJS = \
 	nodeFunctionscan.o \
 	nodeGather.o \
 	nodeGatherMerge.o \
+	nodeGraphScan.o \
 	nodeGroup.o \
 	nodeHash.o \
 	nodeHashjoin.o \
diff --git a/src/backend/executor/execAmi.c b/src/backend/executor/execAmi.c
index 37fe03fdc37..87b1ea666ac 100644
--- a/src/backend/executor/execAmi.c
+++ b/src/backend/executor/execAmi.c
@@ -27,6 +27,7 @@
 #include "executor/nodeCustom.h"
 #include "executor/nodeForeignscan.h"
 #include "executor/nodeFunctionscan.h"
+#include "executor/nodeGraphScan.h"
 #include "executor/nodeGather.h"
 #include "executor/nodeGatherMerge.h"
 #include "executor/nodeGroup.h"
@@ -299,6 +300,10 @@ ExecReScan(PlanState *node)
 			ExecReScanLimit((LimitState *) node);
 			break;
 
+		case T_GraphScanState:
+			ExecReScanGraphScan((GraphScanState *) node);
+			break;
+
 		default:
 			elog(ERROR, "unrecognized node type: %d", (int) nodeTag(node));
 			break;
@@ -569,6 +574,7 @@ ExecSupportsBackwardScan(Plan *node)
 			return false;
 
 		case T_SeqScan:
+		case T_GraphScan:
 		case T_TidScan:
 		case T_TidRangeScan:
 		case T_FunctionScan:
diff --git a/src/backend/executor/execCurrent.c b/src/backend/executor/execCurrent.c
index 9058de2e998..c337547c33f 100644
--- a/src/backend/executor/execCurrent.c
+++ b/src/backend/executor/execCurrent.c
@@ -338,6 +338,7 @@ search_plan_tree(PlanState *node, Oid table_oid,
 		case T_TidRangeScanState:
 		case T_ForeignScanState:
 		case T_CustomScanState:
+		case T_GraphScanState:
 			{
 				ScanState  *sstate = (ScanState *) node;
 
diff --git a/src/backend/executor/execMain.c b/src/backend/executor/execMain.c
index fde502efd38..0c1c930734f 100644
--- a/src/backend/executor/execMain.c
+++ b/src/backend/executor/execMain.c
@@ -611,10 +611,12 @@ ExecCheckPermissions(List *rangeTable, List *rteperminfos,
 			/*
 			 * Only relation RTEs and subquery RTEs that were once relation
 			 * RTEs (views, property graphs) have their perminfoindex set.
+			 * RTE_GRAPH_TABLE also has a perminfoindex.
 			 */
 			Assert(rte->rtekind == RTE_RELATION ||
 				   (rte->rtekind == RTE_SUBQUERY &&
-					(rte->relkind == RELKIND_VIEW || rte->relkind == RELKIND_PROPGRAPH)));
+					(rte->relkind == RELKIND_VIEW || rte->relkind == RELKIND_PROPGRAPH)) ||
+				   rte->rtekind == RTE_GRAPH_TABLE);
 
 			(void) getRTEPermissionInfo(rteperminfos, rte);
 			/* Many-to-one mapping not allowed */
diff --git a/src/backend/executor/execParallel.c b/src/backend/executor/execParallel.c
index 81b87d82fab..0db7293c2b9 100644
--- a/src/backend/executor/execParallel.c
+++ b/src/backend/executor/execParallel.c
@@ -301,6 +301,7 @@ ExecParallelEstimate(PlanState *planstate, ExecParallelEstimateContext *e)
 								   e->pcxt);
 			break;
 		case T_CustomScanState:
+		case T_GraphScanState:
 			if (planstate->plan->parallel_aware)
 				ExecCustomScanEstimate((CustomScanState *) planstate,
 									   e->pcxt);
@@ -549,6 +550,7 @@ ExecParallelInitializeDSM(PlanState *planstate,
 										d->pcxt);
 			break;
 		case T_CustomScanState:
+		case T_GraphScanState:
 			if (planstate->plan->parallel_aware)
 				ExecCustomScanInitializeDSM((CustomScanState *) planstate,
 											d->pcxt);
@@ -1057,6 +1059,7 @@ ExecParallelReInitializeDSM(PlanState *planstate,
 				ExecAppendReInitializeDSM((AppendState *) planstate, pcxt);
 			break;
 		case T_CustomScanState:
+		case T_GraphScanState:
 			if (planstate->plan->parallel_aware)
 				ExecCustomScanReInitializeDSM((CustomScanState *) planstate,
 											  pcxt);
@@ -1448,6 +1451,7 @@ ExecParallelInitializeWorker(PlanState *planstate, ParallelWorkerContext *pwcxt)
 				ExecAppendInitializeWorker((AppendState *) planstate, pwcxt);
 			break;
 		case T_CustomScanState:
+		case T_GraphScanState:
 			if (planstate->plan->parallel_aware)
 				ExecCustomScanInitializeWorker((CustomScanState *) planstate,
 											   pwcxt);
diff --git a/src/backend/executor/execProcnode.c b/src/backend/executor/execProcnode.c
index 7c4c66e323f..a1f511cf43c 100644
--- a/src/backend/executor/execProcnode.c
+++ b/src/backend/executor/execProcnode.c
@@ -84,6 +84,7 @@
 #include "executor/nodeCustom.h"
 #include "executor/nodeForeignscan.h"
 #include "executor/nodeFunctionscan.h"
+#include "executor/nodeGraphScan.h"
 #include "executor/nodeGather.h"
 #include "executor/nodeGatherMerge.h"
 #include "executor/nodeGroup.h"
@@ -291,6 +292,11 @@ ExecInitNode(Plan *node, EState *estate, int eflags)
 													  estate, eflags);
 			break;
 
+		case T_GraphScan:
+			result = (PlanState *) ExecInitGraphScan((GraphScan *) node,
+													 estate, eflags);
+			break;
+
 			/*
 			 * join nodes
 			 */
@@ -665,6 +671,10 @@ ExecEndNode(PlanState *node)
 			ExecEndCustomScan((CustomScanState *) node);
 			break;
 
+		case T_GraphScanState:
+			ExecEndGraphScan((GraphScanState *) node);
+			break;
+
 			/*
 			 * join nodes
 			 */
diff --git a/src/backend/executor/meson.build b/src/backend/executor/meson.build
index dc45be0b2ce..18d2180ce44 100644
--- a/src/backend/executor/meson.build
+++ b/src/backend/executor/meson.build
@@ -32,6 +32,7 @@ backend_sources += files(
   'nodeFunctionscan.c',
   'nodeGather.c',
   'nodeGatherMerge.c',
+  'nodeGraphScan.c',
   'nodeGroup.c',
   'nodeHash.c',
   'nodeHashjoin.c',
diff --git a/src/backend/nodes/nodeFuncs.c b/src/backend/nodes/nodeFuncs.c
index 2a2e00b372e..fcf3618460c 100644
--- a/src/backend/nodes/nodeFuncs.c
+++ b/src/backend/nodes/nodeFuncs.c
@@ -753,6 +753,12 @@ strip_implicit_coercions(Node *node)
 		if (c->coercionformat == COERCE_IMPLICIT_CAST)
 			return strip_implicit_coercions((Node *) c->arg);
 	}
+	else if (IsA(node, CollateExpr))
+	{
+		CollateExpr *c = (CollateExpr *) node;
+
+		return strip_implicit_coercions((Node *) c->arg);
+	}
 	return node;
 }
 
@@ -4938,6 +4944,9 @@ planstate_tree_walker_impl(PlanState *planstate,
 					return true;
 			}
 			break;
+		case T_GraphScan:
+			/* GraphScan has no special children beyond lefttree/righttree */
+			break;
 		default:
 			break;
 	}
diff --git a/src/backend/optimizer/path/allpaths.c b/src/backend/optimizer/path/allpaths.c
index 9c040ecefc8..c23c69f0fec 100644
--- a/src/backend/optimizer/path/allpaths.c
+++ b/src/backend/optimizer/path/allpaths.c
@@ -117,6 +117,8 @@ static void set_foreign_pathlist(PlannerInfo *root, RelOptInfo *rel,
 								 RangeTblEntry *rte);
 static void set_append_rel_size(PlannerInfo *root, RelOptInfo *rel,
 								Index rti, RangeTblEntry *rte);
+static void find_outer_var_varnos(Node *node, Index scanrelid,
+								  Relids *result);
 static void set_append_rel_pathlist(PlannerInfo *root, RelOptInfo *rel,
 									Index rti, RangeTblEntry *rte);
 static void set_grouped_rel_pathlist(PlannerInfo *root, RelOptInfo *rel);
@@ -149,6 +151,8 @@ static void set_result_pathlist(PlannerInfo *root, RelOptInfo *rel,
 								RangeTblEntry *rte);
 static void set_worktable_pathlist(PlannerInfo *root, RelOptInfo *rel,
 								   RangeTblEntry *rte);
+static void set_graph_pathlist(PlannerInfo *root, RelOptInfo *rel,
+							   RangeTblEntry *rte);
 static RelOptInfo *make_rel_from_joinlist(PlannerInfo *root, List *joinlist);
 static bool subquery_is_pushdown_safe(Query *subquery, Query *topquery,
 									  pushdown_safety_info *safetyInfo);
@@ -500,6 +504,14 @@ set_rel_size(PlannerInfo *root, RelOptInfo *rel,
 				/* Might as well just build the path immediately */
 				set_result_pathlist(root, rel, rte);
 				break;
+			case RTE_GRAPH_TABLE:
+				if (enable_native_graphtable)
+				{
+					set_plain_rel_size(root, rel, rte);
+					break;
+				}
+				elog(ERROR, "unexpected rtekind: %d", (int) rel->rtekind);
+				break;
 			default:
 				elog(ERROR, "unexpected rtekind: %d", (int) rel->rtekind);
 				break;
@@ -574,6 +586,14 @@ set_rel_pathlist(PlannerInfo *root, RelOptInfo *rel,
 			case RTE_RESULT:
 				/* simple Result --- fully handled during set_rel_size */
 				break;
+			case RTE_GRAPH_TABLE:
+				if (enable_native_graphtable)
+				{
+					set_graph_pathlist(root, rel, rte);
+					break;
+				}
+				elog(ERROR, "unexpected rtekind: %d", (int) rel->rtekind);
+				break;
 			default:
 				elog(ERROR, "unexpected rtekind: %d", (int) rel->rtekind);
 				break;
@@ -793,12 +813,14 @@ set_rel_consider_parallel(PlannerInfo *root, RelOptInfo *rel,
 			break;
 
 		case RTE_GRAPH_TABLE:
-
-			/*
-			 * Shouldn't happen since these are replaced by subquery RTEs when
-			 * rewriting queries.
-			 */
-			Assert(false);
+			if (enable_native_graphtable)
+			{
+				set_plain_rel_size(root, rel, rte);
+				break;
+			}
+			ereport(ERROR,
+					(errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+					 errmsg("native graph table execution is disabled")));
 			return;
 
 		case RTE_GROUP:
@@ -3235,6 +3257,65 @@ set_worktable_pathlist(PlannerInfo *root, RelOptInfo *rel, RangeTblEntry *rte)
 	add_path(rel, create_worktablescan_path(root, rel, required_outer));
 }
 
+void
+set_graph_pathlist(PlannerInfo *root, RelOptInfo *rel, RangeTblEntry *rte)
+{
+	GraphPath  *gpath = makeNode(GraphPath);
+	Relids		required_outer = NULL;
+
+	gpath->path.pathtype = T_GraphScan;
+	gpath->path.parent = rel;
+	gpath->path.pathtarget = rel->reltarget;
+	gpath->path.rows = rel->rows;
+	gpath->path.startup_cost = 0;
+	gpath->path.total_cost = rel->rows * cpu_tuple_cost;
+	gpath->path.pathkeys = NIL;
+	gpath->graph_oid = rte->relid;
+	gpath->graph_pattern = rte->graph_pattern;
+
+	/*
+	 * If the element WHERE clauses reference outer relations (LATERAL
+	 * references), create a parameterized path so the planner orders the
+	 * NestLoop correctly.
+	 */
+	if (rte->graph_pattern != NULL)
+	{
+		ListCell   *lc;
+
+		foreach(lc, rte->graph_pattern->path_pattern_list)
+		{
+			GraphElementPattern *gep;
+
+			if (!IsA(lfirst(lc), GraphElementPattern))
+				continue;
+			gep = (GraphElementPattern *) lfirst(lc);
+
+			if (gep->whereClause)
+				find_outer_var_varnos(gep->whereClause, rel->relid, &required_outer);
+			if (gep->subexpr)
+			{
+				ListCell   *slc;
+
+				foreach(slc, gep->subexpr)
+					find_outer_var_varnos((Node *) lfirst(slc), rel->relid, &required_outer);
+			}
+		}
+		if (rte->graph_pattern->whereClause)
+			find_outer_var_varnos(rte->graph_pattern->whereClause, rel->relid, &required_outer);
+	}
+
+	if (!bms_is_empty(required_outer))
+	{
+		ParamPathInfo *param_info;
+
+		param_info = get_baserel_parampathinfo(root, rel, required_outer);
+		gpath->path.param_info = param_info;
+		gpath->path.rows = param_info->ppi_rows;
+	}
+
+	add_path(rel, (Path *) gpath);
+}
+
 /*
  * generate_gather_paths
  *		Generate parallel access paths for a relation by pushing a Gather or
@@ -5149,3 +5230,73 @@ generate_partitionwise_join_paths(PlannerInfo *root, RelOptInfo *rel)
 	add_paths_to_append_rel(root, rel, live_children);
 	list_free(live_children);
 }
+
+/*
+ * Walk an expression tree and collect the varnos of any Var nodes
+ * that reference a relation other than the scan's own relation.
+ * This is used to detect LATERAL references in graph element WHERE
+ * clauses for proper parameterization.
+ */
+static void
+find_outer_var_varnos(Node *node, Index scanrelid, Relids *result)
+{
+	if (node == NULL)
+		return;
+
+	if (IsA(node, Var))
+	{
+		Var		   *var = (Var *) node;
+
+		if (var->varno > 0 && var->varno != scanrelid &&
+			!bms_is_member(var->varno, *result))
+			*result = bms_add_member(*result, var->varno);
+		return;
+	}
+
+	if (IsA(node, OpExpr))
+	{
+		OpExpr	   *op = (OpExpr *) node;
+		ListCell   *lc;
+
+		foreach(lc, op->args)
+			find_outer_var_varnos((Node *) lfirst(lc), scanrelid, result);
+	}
+	else if (IsA(node, BoolExpr))
+	{
+		BoolExpr   *b = (BoolExpr *) node;
+		ListCell   *lc;
+
+		foreach(lc, b->args)
+			find_outer_var_varnos((Node *) lfirst(lc), scanrelid, result);
+	}
+	else if (IsA(node, RelabelType))
+		find_outer_var_varnos((Node *) ((RelabelType *) node)->arg,
+							  scanrelid, result);
+	else if (IsA(node, CoerceViaIO))
+		find_outer_var_varnos((Node *) ((CoerceViaIO *) node)->arg,
+							  scanrelid, result);
+	else if (IsA(node, FuncExpr))
+	{
+		FuncExpr   *f = (FuncExpr *) node;
+		ListCell   *lc;
+
+		foreach(lc, f->args)
+			find_outer_var_varnos((Node *) lfirst(lc), scanrelid, result);
+	}
+	else if (IsA(node, ScalarArrayOpExpr))
+	{
+		ScalarArrayOpExpr *s = (ScalarArrayOpExpr *) node;
+		ListCell   *lc;
+
+		foreach(lc, s->args)
+			find_outer_var_varnos((Node *) lfirst(lc), scanrelid, result);
+	}
+	else if (IsA(node, NullIfExpr))
+	{
+		NullIfExpr *n = (NullIfExpr *) node;
+		ListCell   *lc;
+
+		foreach(lc, n->args)
+			find_outer_var_varnos((Node *) lfirst(lc), scanrelid, result);
+	}
+}
diff --git a/src/backend/optimizer/path/costsize.c b/src/backend/optimizer/path/costsize.c
index ac523ecf9a8..adc6eefce8d 100644
--- a/src/backend/optimizer/path/costsize.c
+++ b/src/backend/optimizer/path/costsize.c
@@ -142,6 +142,7 @@ int			effective_cache_size = DEFAULT_EFFECTIVE_CACHE_SIZE;
 Cost		disable_cost = 1.0e10;
 
 int			max_parallel_workers_per_gather = 2;
+int			max_vle_stack_depth = 1000;
 
 bool		enable_seqscan = true;
 bool		enable_indexscan = true;
@@ -155,6 +156,7 @@ bool		enable_groupagg = true;
 bool		enable_nestloop = true;
 bool		enable_material = true;
 bool		enable_memoize = true;
+bool		enable_native_graphtable = true;
 bool		enable_mergejoin = true;
 bool		enable_hashjoin = true;
 bool		enable_gathermerge = true;
diff --git a/src/backend/optimizer/plan/createplan.c b/src/backend/optimizer/plan/createplan.c
index 2c696ea0268..329c27ad641 100644
--- a/src/backend/optimizer/plan/createplan.c
+++ b/src/backend/optimizer/plan/createplan.c
@@ -37,7 +37,6 @@
 #include "optimizer/restrictinfo.h"
 #include "optimizer/subselect.h"
 #include "optimizer/tlist.h"
-#include "parser/parse_clause.h"
 #include "parser/parsetree.h"
 #include "partitioning/partprune.h"
 #include "tcop/tcopprot.h"
@@ -157,6 +156,9 @@ static ForeignScan *create_foreignscan_plan(PlannerInfo *root, ForeignPath *best
 static CustomScan *create_customscan_plan(PlannerInfo *root,
 										  CustomPath *best_path,
 										  List *tlist, List *scan_clauses);
+static Plan *create_graphscan_plan(PlannerInfo *root,
+								   GraphPath * best_path,
+								   List *tlist, List *scan_clauses);
 static NestLoop *create_nestloop_plan(PlannerInfo *root, NestPath *best_path);
 static MergeJoin *create_mergejoin_plan(PlannerInfo *root, MergePath *best_path);
 static HashJoin *create_hashjoin_plan(PlannerInfo *root, HashPath *best_path);
@@ -418,6 +420,7 @@ create_plan_recurse(PlannerInfo *root, Path *best_path, int flags)
 		case T_NamedTuplestoreScan:
 		case T_ForeignScan:
 		case T_CustomScan:
+		case T_GraphScan:
 			plan = create_scan_plan(root, best_path, flags);
 			break;
 		case T_HashJoin:
@@ -795,6 +798,13 @@ create_scan_plan(PlannerInfo *root, Path *best_path, int flags)
 												   scan_clauses);
 			break;
 
+		case T_GraphScan:
+			plan = (Plan *) create_graphscan_plan(root,
+												  (GraphPath *) best_path,
+												  tlist,
+												  scan_clauses);
+			break;
+
 		default:
 			elog(ERROR, "unrecognized node type: %d",
 				 (int) best_path->pathtype);
@@ -4182,6 +4192,233 @@ create_customscan_plan(PlannerInfo *root, CustomPath *best_path,
 	return cplan;
 }
 
+/*
+ * Helpers for LATERAL reference handling in graph scans.
+ */
+static bool contains_outer_var(Node *node, Index scanrelid);
+static void extract_graph_outer_quals(GraphPattern *pattern,
+									  Index scanrelid,
+									  List **extra_quals);
+
+/* ----------------------------------------------------------------
+ *	create_graphscan_plan
+ *
+ *		Transform a GraphPath into a GraphScan plan node.
+ * ----------------------------------------------------------------
+ */
+static Plan *
+create_graphscan_plan(PlannerInfo *root, GraphPath * best_path,
+					  List *tlist, List *scan_clauses)
+{
+	GraphScan  *scan;
+	Scan	   *scan_node;
+
+	scan = makeNode(GraphScan);
+	scan_node = &scan->scan;
+
+	/* Copy cost info from Path to Plan */
+	copy_generic_path_info(&scan_node->plan, &best_path->path);
+
+	/* Set target list and qual, unwrapping RestrictInfo nodes */
+	scan_node->plan.targetlist = tlist;
+	{
+		List	   *new_qual = NIL;
+		ListCell   *lc;
+
+		foreach(lc, scan_clauses)
+		{
+			Node	   *clause = (Node *) lfirst(lc);
+
+			while (clause != NULL && IsA(clause, RestrictInfo))
+				clause = (Node *) ((RestrictInfo *) clause)->clause;
+			if (clause)
+				new_qual = lappend(new_qual, clause);
+		}
+		scan_node->plan.qual = new_qual;
+	}
+	scan_node->plan.lefttree = NULL;
+	scan_node->plan.righttree = NULL;
+
+	/*
+	 * Replace bare Var references in the target list with the actual column
+	 * expressions from graph_table_columns.  This ensures that function
+	 * calls, coercions, and other wrappers around property references (e.g.,
+	 * upper(a.vname), a.vname COLLATE "C") are evaluated by the GraphScan's
+	 * projection (ExecProject) rather than being silently stripped when we
+	 * only resolve raw property values.
+	 */
+	{
+		RangeTblEntry *rte = root->simple_rte_array[
+													best_path->path.parent->relid];
+		List	   *gtcols = rte->graph_table_columns;
+		ListCell   *lc;
+
+		foreach(lc, scan_node->plan.targetlist)
+		{
+			TargetEntry *te = (TargetEntry *) lfirst(lc);
+
+			if (IsA(te->expr, Var))
+			{
+				Var		   *var = (Var *) te->expr;
+
+				if (var->varno == scan_node->scanrelid &&
+					var->varattno > 0 &&
+					var->varattno <= list_length(gtcols))
+				{
+					TargetEntry *gte = (TargetEntry *)
+						list_nth(gtcols, var->varattno - 1);
+
+					te->expr = (Expr *) copyObject(gte->expr);
+				}
+			}
+		}
+	}
+
+	/* Copy graph-specific fields */
+	scan->graph_oid = best_path->graph_oid;
+	scan->graph_pattern = best_path->graph_pattern;
+	scan->path_mode = PATH_MODE_WALK;
+	scan->search_algo = SEARCH_DFS;
+
+	/* scanrelid points to the RTE_GRAPH_TABLE entry */
+	scan_node->scanrelid = best_path->path.parent->relid;
+
+	/*
+	 * Extract conditions from element-level WHERE clauses that reference
+	 * outer relations (LATERAL references) and add them to the plan's qual.
+	 * This ensures they go through fix_scan_expr in setrefs.c (which converts
+	 * outer Vars to OUTER_VAR) and are evaluated via ExecQual in the NestLoop
+	 * context where ecxt_outertuple is set correctly.
+	 */
+	{
+		List	   *extra_quals = NIL;
+
+		if (scan->graph_pattern != NULL)
+			extract_graph_outer_quals(scan->graph_pattern,
+									  scan_node->scanrelid,
+									  &extra_quals);
+		if (extra_quals != NIL)
+			scan_node->plan.qual =
+				list_concat(scan_node->plan.qual, extra_quals);
+	}
+
+	return (Plan *) scan;
+}
+
+/*
+ * Check whether an expression tree contains a Var node referencing
+ * a relation other than the scan's own relation (i.e. a LATERAL
+ * outer reference).
+ */
+static bool
+contains_outer_var(Node *node, Index scanrelid)
+{
+	if (node == NULL)
+		return false;
+
+	if (IsA(node, Var))
+	{
+		Var		   *var = (Var *) node;
+
+		return (var->varno > 0 && var->varno != scanrelid);
+	}
+
+	if (IsA(node, OpExpr))
+	{
+		OpExpr	   *op = (OpExpr *) node;
+		ListCell   *lc;
+
+		foreach(lc, op->args)
+			if (contains_outer_var((Node *) lfirst(lc), scanrelid))
+			return true;
+		return false;
+	}
+	if (IsA(node, BoolExpr))
+	{
+		BoolExpr   *b = (BoolExpr *) node;
+		ListCell   *lc;
+
+		foreach(lc, b->args)
+			if (contains_outer_var((Node *) lfirst(lc), scanrelid))
+			return true;
+		return false;
+	}
+	if (IsA(node, RelabelType))
+		return contains_outer_var((Node *) ((RelabelType *) node)->arg,
+								  scanrelid);
+	if (IsA(node, CoerceViaIO))
+		return contains_outer_var((Node *) ((CoerceViaIO *) node)->arg,
+								  scanrelid);
+	if (IsA(node, FuncExpr))
+	{
+		FuncExpr   *f = (FuncExpr *) node;
+		ListCell   *lc;
+
+		foreach(lc, f->args)
+			if (contains_outer_var((Node *) lfirst(lc), scanrelid))
+			return true;
+		return false;
+	}
+	if (IsA(node, ScalarArrayOpExpr))
+	{
+		ScalarArrayOpExpr *s = (ScalarArrayOpExpr *) node;
+		ListCell   *lc;
+
+		foreach(lc, s->args)
+			if (contains_outer_var((Node *) lfirst(lc), scanrelid))
+			return true;
+		return false;
+	}
+	if (IsA(node, NullIfExpr))
+	{
+		NullIfExpr *n = (NullIfExpr *) node;
+		ListCell   *lc;
+
+		foreach(lc, n->args)
+			if (contains_outer_var((Node *) lfirst(lc), scanrelid))
+			return true;
+		return false;
+	}
+	return false;
+}
+
+/*
+ * Walk the graph pattern and extract all element-level WHERE clause
+ * expressions that reference outer relations.  These are added to
+ * the plan's qual for proper LATERAL join handling.
+ */
+static void
+extract_graph_outer_quals(GraphPattern *pattern, Index scanrelid,
+						  List **extra_quals)
+{
+	ListCell   *lc;
+
+	foreach(lc, pattern->path_pattern_list)
+	{
+		GraphElementPattern *gep;
+
+		if (!IsA(lfirst(lc), GraphElementPattern))
+			continue;
+		gep = (GraphElementPattern *) lfirst(lc);
+
+		if (gep->whereClause &&
+			contains_outer_var(gep->whereClause, scanrelid))
+			*extra_quals = lappend(*extra_quals, gep->whereClause);
+		if (gep->subexpr)
+		{
+			ListCell   *slc;
+
+			foreach(slc, gep->subexpr)
+			{
+				Node	   *sub = (Node *) lfirst(slc);
+
+				if (contains_outer_var(sub, scanrelid))
+					*extra_quals = lappend(*extra_quals, sub);
+			}
+		}
+	}
+}
+
 
 /*****************************************************************************
  *
diff --git a/src/backend/optimizer/plan/setrefs.c b/src/backend/optimizer/plan/setrefs.c
index e1182255055..1ca8ce2a9a1 100644
--- a/src/backend/optimizer/plan/setrefs.c
+++ b/src/backend/optimizer/plan/setrefs.c
@@ -872,6 +872,19 @@ set_plan_refs(PlannerInfo *root, Plan *plan, int rtoffset)
 		case T_CustomScan:
 			set_customscan_references(root, (CustomScan *) plan, rtoffset);
 			break;
+		case T_GraphScan:
+			{
+				GraphScan  *splan = (GraphScan *) plan;
+
+				splan->scan.scanrelid += rtoffset;
+				splan->scan.plan.targetlist =
+					fix_scan_list(root, splan->scan.plan.targetlist,
+								  rtoffset, NUM_EXEC_TLIST(plan));
+				splan->scan.plan.qual =
+					fix_scan_list(root, splan->scan.plan.qual,
+								  rtoffset, NUM_EXEC_QUAL(plan));
+			}
+			break;
 
 		case T_NestLoop:
 		case T_MergeJoin:
diff --git a/src/backend/optimizer/plan/subselect.c b/src/backend/optimizer/plan/subselect.c
index 6aa8971c95d..3c896ee4094 100644
--- a/src/backend/optimizer/plan/subselect.c
+++ b/src/backend/optimizer/plan/subselect.c
@@ -2662,6 +2662,7 @@ finalize_plan(PlannerInfo *root, Plan *plan,
 			break;
 
 		case T_SeqScan:
+		case T_GraphScan:
 			context.paramids = bms_add_members(context.paramids, scan_params);
 			break;
 
diff --git a/src/backend/optimizer/prep/prepjointree.c b/src/backend/optimizer/prep/prepjointree.c
index 72d39ba30fd..fa33bb57a6c 100644
--- a/src/backend/optimizer/prep/prepjointree.c
+++ b/src/backend/optimizer/prep/prepjointree.c
@@ -1654,8 +1654,7 @@ pull_up_simple_subquery(PlannerInfo *root, Node *jtnode, RangeTblEntry *rte,
 					/* these can't contain any lateral references */
 					break;
 				case RTE_GRAPH_TABLE:
-					/* shouldn't happen here */
-					Assert(false);
+					child_rte->lateral = true;
 					break;
 			}
 		}
@@ -2723,8 +2722,7 @@ replace_vars_in_jointree(Node *jtnode,
 						Assert(false);
 						break;
 					case RTE_GRAPH_TABLE:
-						/* shouldn't happen here */
-						Assert(false);
+						/* graph tables are always LATERAL */
 						break;
 				}
 			}
diff --git a/src/backend/optimizer/util/relnode.c b/src/backend/optimizer/util/relnode.c
index 687e923c46c..185614b140a 100644
--- a/src/backend/optimizer/util/relnode.c
+++ b/src/backend/optimizer/util/relnode.c
@@ -391,6 +391,15 @@ build_simple_rel(PlannerInfo *root, int relid, RelOptInfo *parent)
 			rel->attr_needed = NULL;
 			rel->attr_widths = NULL;
 			break;
+		case RTE_GRAPH_TABLE:
+			/* columns come from eref */
+			rel->min_attr = 0;
+			rel->max_attr = list_length(rte->eref->colnames);
+			rel->attr_needed = (Relids *)
+				palloc0_array(Relids, rel->max_attr - rel->min_attr + 1);
+			rel->attr_widths = (int32 *)
+				palloc0_array(int32, rel->max_attr - rel->min_attr + 1);
+			break;
 		default:
 			elog(ERROR, "unrecognized RTE kind: %d",
 				 (int) rte->rtekind);
diff --git a/src/backend/parser/gram.y b/src/backend/parser/gram.y
index 17035fb4d15..b69906c58f6 100644
--- a/src/backend/parser/gram.y
+++ b/src/backend/parser/gram.y
@@ -18431,6 +18431,7 @@ opt_graph_pattern_quantifier:
 			'{' Iconst '}'					{ $$ = list_make2_int($2, $2); }
 			| '{' ',' Iconst '}'			{ $$ = list_make2_int(0, $3); }
 			| '{' Iconst ',' Iconst '}'		{ $$ = list_make2_int($2, $4); }
+			| '{' Iconst ',' '}'			{ $$ = list_make2_int($2, -1); }
 			| /*EMPTY*/						{ $$ = NULL; }
 		;
 
